/*
 * Initieel main.c bestand gegenereerd door Glade. Wijzig indien nodig.
 * Glade zal dit bestand niet overschrijven.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <poslib/poslib.h>

#include "interface.h"
#include "support.h"
#include "callbacks.h"
#include "io.h"
#include "main.h"

GtkWidget *frmMain = (GtkWidget *)NULL;
GtkWidget *frmAbout = (GtkWidget *)NULL;
GtkWidget *frmZoneConfig = (GtkWidget *)NULL;

bool dom_readonly = false;
char mfeditrc[PATH_MAX] = "";
char pwd[PATH_MAX] = "";
int nrecent = 5;
GtkWidget** recent = NULL;
char** recentnam = NULL;

void initrecentitems(int nrecent) {
  GtkTooltips *tooltips = (GtkTooltips*)gtk_object_get_data(GTK_OBJECT(frmMain), "tooltips");

  recent = (GtkWidget **)calloc(nrecent, sizeof(GtkWidget *));
  recentnam = (char **)calloc(nrecent, sizeof(char *));

  for (int x = 0; x < nrecent; x++) {
    recent[x] = gtk_menu_item_new_with_label("");
    gtk_container_add (GTK_CONTAINER(lookup_widget(frmMain, "mnuFile_menu")), recent[x]);
    gtk_tooltips_set_tip (tooltips, recent[x], "Open this recent file", NULL);
    gtk_signal_connect (GTK_OBJECT (recent[x]), "activate",
        GTK_SIGNAL_FUNC (on_cmdFileRecent_activate),
        NULL);
//  gtk_widget_add_accelerator (mnuFileOpen, "activate", accel_group,
//                              GDK_O, GDK_CONTROL_MASK,
//                              GTK_ACCEL_VISIBLE);
  }
}

/* configuration file */
void read_mfeditrc() {
  char *ptr = getenv("MFEDITRC");

  if (ptr && strlen(ptr) < sizeof(mfeditrc)) {
    strcpy(mfeditrc, ptr);
  } else {
#ifdef _WIN32
    ptr = getenv("USERPROFILE"); /* windows 2k/xp */
    if (ptr && strlen(ptr) < sizeof(mfeditrc)) {
      strcpy(mfeditrc, ptr);
    } else if (GetWindowsDirectory(mfeditrc, PATH_MAX) == 0) {
      mfeditrc[0] = 0;
    }
    if (mfeditrc[0]) {
      if (strlen(mfeditrc) + strlen("mfeditrc.txt") + 1 < sizeof(mfeditrc)) {
        if (mfeditrc[strlen(mfeditrc) - 1] != '\\') strcat(mfeditrc, "\\");
        strcat(mfeditrc, "mfeditrc.txt");
      } else {
        mfeditrc[0] = 0;
      }
    }
#else
    char *ptr = getenv("HOME");
    if (ptr && strlen(ptr) + strlen(".mfeditrc") + 1 < sizeof(mfeditrc)) {
      strcpy(mfeditrc, ptr);
      if (mfeditrc[strlen(mfeditrc) - 1] != PATHDELIMC) strcat(mfeditrc, PATHDELIM);
      strcat(mfeditrc, ".mfeditrc");
    }
#endif
  }
  if (mfeditrc[0]) {
    FILE *f = try_fopen_r(mfeditrc);
    char *ptr;
    char buff[PATH_MAX];
    int x;
    if (f) {
      while (!feof(f)) {
        if (fgets(buff, sizeof(buff), f)) {
          /* remove newlines */
          ptr = buff + strlen(buff) - 1;
          while ((*ptr == '\n' || *ptr == '\r') && ptr >= buff) {
            *ptr = '\0';
          }
          /* check for name=value pairs */
          if ( (ptr = strchr(buff, '=')) != NULL ) {
            *ptr = '\0'; ptr++;
            if (strcmpi(buff, "pwd") == 0) {
              strcpy(pwd, ptr);
              if (pwd[0] && pwd[strlen(pwd)-1] != PATHDELIMC) strcat(pwd, PATHDELIM);
            } else if (strcmpi(buff, "nrecent") == 0) {
              if (!recent) {
                try {
                  nrecent = txt_to_int(ptr);
                  initrecentitems(nrecent);
                } catch (PException p) { }
              }
            } else if (strcmpi(buff, "updateserial") == 0) {
              try { do_update_serial = txt_to_bool(ptr); }
              catch (PException p) { }
            } else if (strcmpi(buff, "recent") == 0) {
              if (!recent) initrecentitems(nrecent);
              for (x = 0; x < nrecent; x++) {
                if (!recentnam[x]) {
                  /* add menu item */
                  gtk_label_set_text(GTK_LABEL(GTK_BIN(recent[x])->child), ptr);
                  if (recentnam[x]) free(recentnam[x]);
                  recentnam[x] = strdup(ptr);
                  gtk_widget_show (recent[x]);
                  break;
                }
              }
            }
          }
        }
      }
    }
  }
  if (!recent) initrecentitems(nrecent);
}

/* this code is also in sans FfrmZones.cpp; changes here should also be
   applied there! */
gint lstrrs_compare2(GtkCList *list, gconstpointer ptr1, gconstpointer ptr2) {
  domainname dom1, dom2;
  int ret, x;
  const GtkCListRow *row1 = (const GtkCListRow *)ptr1;
  const GtkCListRow *row2 = (const GtkCListRow *)ptr2;
  gchar *type1 = GTK_CELL_TEXT(row1->cell[2])->text,
        *type2 = GTK_CELL_TEXT(row2->cell[2])->text,
        *data1 = GTK_CELL_TEXT(row1->cell[3])->text,
        *data2 = GTK_CELL_TEXT(row2->cell[3])->text;
  dom1 = domainname(GTK_CELL_TEXT(row1->cell[0])->text, znroot);
  dom2 = domainname(GTK_CELL_TEXT(row2->cell[0])->text, znroot);
  ret = domccmp(dom1.c_str(), dom2.c_str());
  if (ret == 0) {
    if ((x = strcmpi(type1, type2)) == 0) return strcmpi(data1, data2);
    else if (x < 0) { if (strcmpi(type2, "soa") == 0) return 1; else return -1; }
    else { if (strcmpi(type1, "soa") == 0) return -1; else return 1; }
  } else if (ret < 0) {
    if (dom2 == znroot) return 1; else return -1;
  } else {
    if (dom1 == znroot) return -1; else return 1;
  }
}

gint lstrrs_compare(GtkCList *list, gconstpointer ptr1, gconstpointer ptr2) {
  gint ret;
  ret = lstrrs_compare2(list, ptr1, ptr2);
  return ret;
}

#ifdef WIN32
#include <windows.h>
#include <winreg.h>
#endif

int
main (int argc, char *argv[])
{
  bool mf_loaded = false;
  gtk_set_locale ();
  gtk_init (&argc, &argv);
  GtkCList *list;

#ifdef WIN32
  add_pixmap_directory (".");

  HKEY hkey;
  DWORD valuetype;
  DWORD buffsize = 2047;
  char buff[2048];
  valuetype = 16;
  if ((RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\Posadis\\Master File Editor", 0, KEY_READ, &hkey) == ERROR_SUCCESS)) {
    if (RegQueryValueEx(hkey, "Pixmaps", NULL, &valuetype, (BYTE*)buff, &buffsize) == ERROR_SUCCESS && valuetype == REG_SZ) {
      RegCloseKey(hkey);
      if (buff[strlen(buff)-1] != '\\') strcat(buff, "\\");
      add_pixmap_directory(buff);
    } else RegCloseKey(hkey);
  }

#endif

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  frmMain = create_frmMain ();
  list = (GtkCList *)lookup_widget(frmMain, "lstRrs");
  gtk_clist_set_compare_func(list, lstrrs_compare);
  gtk_clist_set_auto_sort(list, TRUE);
  discard_current_data();

  read_mfeditrc();

#define USAGE \
  "Usage:\n" \
  "  mfedit [filename|--new|--help|--version|--root-readonly]\n\n" \
  "You can either specify a filename to open, or specify --new if you want the\n" \
  "create new file dialog to pop up, or --help to show this dialog, or --version\n" \
  "to show the About dialog."

  for (int x = 1; x < argc; x++) {
    if (strcmpi(argv[x], "--new") == 0) {
      gtk_widget_show (frmMain);
      frmNew = create_frmNew();
      gtk_entry_set_editable(GTK_ENTRY(lookup_widget(frmNew, "txtRoot")), !dom_readonly);
      gtk_widget_show(frmNew);
    } else if (strcmpi(argv[x], "--version") == 0) {
      gtk_widget_show (frmMain);
      frmAbout = create_frmAbout();
      gtk_widget_show(frmAbout);
    } else if (strcmpi(argv[x], "--help") == 0) {
      show_error_message("The Posadis Master File Editor\n\n"
                         USAGE);
      return 0;
    } else if (strcmpi(argv[x], "--root-readonly") == 0) {
      dom_readonly = true;
    } else if (strcmpi(argv[x], "--pixmapdir") == 0) {
      show_error_message(PACKAGE_DATA_DIR);
      return 0;
    } else if (argv[x][0] == '-') {
      show_error_message("Unrecognized command-line argument!\n\n"
                         USAGE);
      return 1;
    } else {
      if (mf_loaded) {
        show_error_message("Cannot open multiple master files!\n\n"
                           USAGE);
        return 1;
      }
      load_master_file(argv[x]);
      mf_loaded = true;
    }
  }

  gtk_check_menu_item_set_active(
    GTK_CHECK_MENU_ITEM(lookup_widget(frmMain, "mnuToolsAutoserial")),
    do_update_serial);

  gtk_widget_show (frmMain);

  gtk_main ();
  /* write the mfeditrc */
  if (mfeditrc[0]) {
    FILE *f = try_fopen(mfeditrc, "w");
    if (f) {
      fprintf(f, "pwd=%s\n", pwd);
      fprintf(f, "updateserial=%s\n", do_update_serial?"true":"false");
      for (int x = 0; x < nrecent; x++)
        if (recentnam[x]) fprintf(f, "recent=%s\n", recentnam[x]);
      fclose(f);
    }
  }
  if (recent) {
    for (int x = 0; x < nrecent; x++)
      if (recentnam[x]) free(recentnam[x]);
    free(recent);
    free(recentnam);
  }
  
  return 0;
}

